Index: XIOS/branchs/xios-2.5/src/node/axis.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/node/axis.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/node/axis.cpp	(revision 1850)
@@ -57,5 +57,5 @@
      m["temporal_splitting"] = TRANS_TEMPORAL_SPLITTING;
      m["duplicate_scalar"] = TRANS_DUPLICATE_SCALAR_TO_AXIS;
-
+     return true ;
    }
 
Index: XIOS/branchs/xios-2.5/src/node/compute_connectivity_domain.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/node/compute_connectivity_domain.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/node/compute_connectivity_domain.cpp	(revision 1850)
@@ -27,5 +27,5 @@
   bool CComputeConnectivityDomain::registerTrans()
   {
-    registerTransformation(TRANS_COMPUTE_CONNECTIVITY_DOMAIN, CComputeConnectivityDomain::create);
+    return registerTransformation(TRANS_COMPUTE_CONNECTIVITY_DOMAIN, CComputeConnectivityDomain::create);
   }
 
Index: XIOS/branchs/xios-2.5/src/node/domain.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/node/domain.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/node/domain.cpp	(revision 1850)
@@ -77,4 +77,5 @@
      m["expand_domain"] = TRANS_EXPAND_DOMAIN;
      m["reorder_domain"] = TRANS_REORDER_DOMAIN;
+     return true ;
    }
 
Index: XIOS/branchs/xios-2.5/src/node/expand_domain.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/node/expand_domain.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/node/expand_domain.cpp	(revision 1850)
@@ -27,5 +27,5 @@
   bool CExpandDomain::registerTrans()
   {
-    registerTransformation(TRANS_EXPAND_DOMAIN, CExpandDomain::create);
+    return registerTransformation(TRANS_EXPAND_DOMAIN, CExpandDomain::create);
   }
 
Index: XIOS/branchs/xios-2.5/src/node/generate_rectilinear_domain.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/node/generate_rectilinear_domain.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/node/generate_rectilinear_domain.cpp	(revision 1850)
@@ -27,5 +27,5 @@
   bool CGenerateRectilinearDomain::registerTrans()
   {
-    registerTransformation(TRANS_GENERATE_RECTILINEAR_DOMAIN, create);
+    return registerTransformation(TRANS_GENERATE_RECTILINEAR_DOMAIN, create);
   }
 
Index: XIOS/branchs/xios-2.5/src/node/interpolate_domain.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/node/interpolate_domain.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/node/interpolate_domain.cpp	(revision 1850)
@@ -27,5 +27,5 @@
   bool CInterpolateDomain::registerTrans()
   {
-    registerTransformation(TRANS_INTERPOLATE_DOMAIN, create);
+    return registerTransformation(TRANS_INTERPOLATE_DOMAIN, create);
   }
 
Index: XIOS/branchs/xios-2.5/src/node/reorder_domain.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/node/reorder_domain.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/node/reorder_domain.cpp	(revision 1850)
@@ -27,5 +27,5 @@
   bool CReorderDomain::registerTrans()
   {
-    registerTransformation(TRANS_REORDER_DOMAIN, CReorderDomain::create);
+    return registerTransformation(TRANS_REORDER_DOMAIN, CReorderDomain::create);
   }
 
Index: XIOS/branchs/xios-2.5/src/node/scalar.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/node/scalar.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/node/scalar.cpp	(revision 1850)
@@ -35,4 +35,5 @@
      m["reduce_domain"] = TRANS_REDUCE_DOMAIN_TO_SCALAR;
      m["reduce_scalar"] = TRANS_REDUCE_SCALAR_TO_SCALAR;
+     return true ;
    }
 
Index: XIOS/branchs/xios-2.5/src/node/zoom_domain.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/node/zoom_domain.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/node/zoom_domain.cpp	(revision 1850)
@@ -27,5 +27,5 @@
   bool CZoomDomain::registerTrans()
   {
-    registerTransformation(TRANS_ZOOM_DOMAIN, CZoomDomain::create);
+    return registerTransformation(TRANS_ZOOM_DOMAIN, CZoomDomain::create);
   }
 
Index: XIOS/branchs/xios-2.5/src/transformation/Functions/reduction.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/Functions/reduction.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/Functions/reduction.cpp	(revision 1850)
@@ -27,4 +27,5 @@
   m["average"] = TRANS_REDUCE_AVERAGE;
   CAverageReductionAlgorithm::registerTrans();
+  return true ;
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_duplicate_scalar.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_duplicate_scalar.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_duplicate_scalar.cpp	(revision 1850)
@@ -34,5 +34,5 @@
 bool CAxisAlgorithmDuplicateScalar::registerTrans()
 {
-  CGridTransformationFactory<CAxis>::registerTransformation(TRANS_DUPLICATE_SCALAR_TO_AXIS, create);
+  return CGridTransformationFactory<CAxis>::registerTransformation(TRANS_DUPLICATE_SCALAR_TO_AXIS, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_extract_domain.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1850)
@@ -39,5 +39,5 @@
 bool CAxisAlgorithmExtractDomain::registerTrans()
 {
-  CGridTransformationFactory<CAxis>::registerTransformation(TRANS_EXTRACT_DOMAIN_TO_AXIS, create);
+  return CGridTransformationFactory<CAxis>::registerTransformation(TRANS_EXTRACT_DOMAIN_TO_AXIS, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_interpolate.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_interpolate.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_interpolate.cpp	(revision 1850)
@@ -42,5 +42,5 @@
 bool CAxisAlgorithmInterpolate::registerTrans()
 {
-  CGridTransformationFactory<CAxis>::registerTransformation(TRANS_INTERPOLATE_AXIS, create);
+  return CGridTransformationFactory<CAxis>::registerTransformation(TRANS_INTERPOLATE_AXIS, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_inverse.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_inverse.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_inverse.cpp	(revision 1850)
@@ -40,5 +40,5 @@
 bool CAxisAlgorithmInverse::registerTrans()
 {
-  CGridTransformationFactory<CAxis>::registerTransformation(TRANS_INVERSE_AXIS, create);
+  return CGridTransformationFactory<CAxis>::registerTransformation(TRANS_INVERSE_AXIS, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_reduce_axis.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_reduce_axis.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_reduce_axis.cpp	(revision 1850)
@@ -37,5 +37,5 @@
 bool CAxisAlgorithmReduceAxis::registerTrans()
 {
-  CGridTransformationFactory<CAxis>::registerTransformation(TRANS_REDUCE_AXIS_TO_AXIS, create);
+  return CGridTransformationFactory<CAxis>::registerTransformation(TRANS_REDUCE_AXIS_TO_AXIS, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_reduce_domain.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1850)
@@ -38,5 +38,5 @@
 bool CAxisAlgorithmReduceDomain::registerTrans()
 {
-  CGridTransformationFactory<CAxis>::registerTransformation(TRANS_REDUCE_DOMAIN_TO_AXIS, create);
+  return CGridTransformationFactory<CAxis>::registerTransformation(TRANS_REDUCE_DOMAIN_TO_AXIS, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_temporal_splitting.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_temporal_splitting.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_temporal_splitting.cpp	(revision 1850)
@@ -34,5 +34,5 @@
 bool CAxisAlgorithmTemporalSplitting::registerTrans()
 {
-  CGridTransformationFactory<CAxis>::registerTransformation(TRANS_TEMPORAL_SPLITTING, create);
+  return CGridTransformationFactory<CAxis>::registerTransformation(TRANS_TEMPORAL_SPLITTING, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_zoom.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_zoom.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/axis_algorithm_zoom.cpp	(revision 1850)
@@ -35,5 +35,5 @@
 bool CAxisAlgorithmZoom::registerTrans()
 {
-  CGridTransformationFactory<CAxis>::registerTransformation(TRANS_ZOOM_AXIS, create);
+  return CGridTransformationFactory<CAxis>::registerTransformation(TRANS_ZOOM_AXIS, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_compute_connectivity.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_compute_connectivity.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_compute_connectivity.cpp	(revision 1850)
@@ -37,5 +37,5 @@
 bool CDomainAlgorithmComputeConnectivity::registerTrans()
 {
-  CGridTransformationFactory<CDomain>::registerTransformation(TRANS_COMPUTE_CONNECTIVITY_DOMAIN, create);
+  return CGridTransformationFactory<CDomain>::registerTransformation(TRANS_COMPUTE_CONNECTIVITY_DOMAIN, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_expand.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_expand.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_expand.cpp	(revision 1850)
@@ -39,5 +39,5 @@
 bool CDomainAlgorithmExpand::registerTrans()
 {
-  CGridTransformationFactory<CDomain>::registerTransformation(TRANS_EXPAND_DOMAIN, create);
+  return CGridTransformationFactory<CDomain>::registerTransformation(TRANS_EXPAND_DOMAIN, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_interpolate.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_interpolate.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_interpolate.cpp	(revision 1850)
@@ -44,5 +44,5 @@
 bool CDomainAlgorithmInterpolate::registerTrans()
 {
-  CGridTransformationFactory<CDomain>::registerTransformation(TRANS_INTERPOLATE_DOMAIN, create);
+  return CGridTransformationFactory<CDomain>::registerTransformation(TRANS_INTERPOLATE_DOMAIN, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_reorder.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_reorder.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_reorder.cpp	(revision 1850)
@@ -32,5 +32,5 @@
 bool CDomainAlgorithmReorder::registerTrans()
 {
-  CGridTransformationFactory<CDomain>::registerTransformation(TRANS_REORDER_DOMAIN, create);
+  return CGridTransformationFactory<CDomain>::registerTransformation(TRANS_REORDER_DOMAIN, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_zoom.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_zoom.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/domain_algorithm_zoom.cpp	(revision 1850)
@@ -36,5 +36,5 @@
 bool CDomainAlgorithmZoom::registerTrans()
 {
-  CGridTransformationFactory<CDomain>::registerTransformation(TRANS_ZOOM_DOMAIN, create);
+  return CGridTransformationFactory<CDomain>::registerTransformation(TRANS_ZOOM_DOMAIN, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_extract_axis.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_extract_axis.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_extract_axis.cpp	(revision 1850)
@@ -39,5 +39,5 @@
 bool CScalarAlgorithmExtractAxis::registerTrans()
 {
-  CGridTransformationFactory<CScalar>::registerTransformation(TRANS_EXTRACT_AXIS_TO_SCALAR, create);
+  return CGridTransformationFactory<CScalar>::registerTransformation(TRANS_EXTRACT_AXIS_TO_SCALAR, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_reduce_axis.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1850)
@@ -40,5 +40,5 @@
 bool CScalarAlgorithmReduceAxis::registerTrans()
 {
-  CGridTransformationFactory<CScalar>::registerTransformation(TRANS_REDUCE_AXIS_TO_SCALAR, create);
+  return CGridTransformationFactory<CScalar>::registerTransformation(TRANS_REDUCE_AXIS_TO_SCALAR, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_reduce_domain.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1850)
@@ -39,5 +39,5 @@
 bool CScalarAlgorithmReduceDomain::registerTrans()
 {
-  CGridTransformationFactory<CScalar>::registerTransformation(TRANS_REDUCE_DOMAIN_TO_SCALAR, create);
+  return CGridTransformationFactory<CScalar>::registerTransformation(TRANS_REDUCE_DOMAIN_TO_SCALAR, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_reduce_scalar.cpp
===================================================================
--- XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_reduce_scalar.cpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/transformation/scalar_algorithm_reduce_scalar.cpp	(revision 1850)
@@ -35,5 +35,5 @@
 bool CScalarAlgorithmReduceScalar::registerTrans()
 {
-  CGridTransformationFactory<CScalar>::registerTransformation(TRANS_REDUCE_SCALAR_TO_SCALAR, create);
+  return CGridTransformationFactory<CScalar>::registerTransformation(TRANS_REDUCE_SCALAR_TO_SCALAR, create);
 }
 
Index: XIOS/branchs/xios-2.5/src/type/enum_ref_impl.hpp
===================================================================
--- XIOS/branchs/xios-2.5/src/type/enum_ref_impl.hpp	(revision 1786)
+++ XIOS/branchs/xios-2.5/src/type/enum_ref_impl.hpp	(revision 1850)
@@ -236,4 +236,5 @@
     else ERROR("template <typename T> bool CEnum_ref<T>::_fromBuffer(CBufferIn& buffer)",
                << "incompatibility between enumeration and standard integer type");
+    return ret ;
   }
  